
#include <windows.h>
#include "../../../Mausuji/plugin.h"
#include "resource.h"

BOOL Init(void);
void Quit(void);
void Config(PREFS* prefs, COMMANDPARAM* param);
void Command(HWND hwnd, LPCWSTR path, COMMANDPARAM* param);

PLUGIN plugin = {
	PLUGIN_VERSION,
	L"sample plugin",
	Init,
	Quit,
	Config,
	Command
};

EXTERN_C PLUGIN * WINAPI GetPlugin(void)
{
	return &plugin;
}

INT_PTR CALLBACK DlgProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	static COMMANDPARAM* param;
	switch(msg)
	{
	case WM_INITDIALOG:
		param = (COMMANDPARAM*)lParam;
		SetDlgItemInt(hwnd, IDC_EDIT1, param->nValue[0], TRUE);
		SetDlgItemInt(hwnd, IDC_EDIT2, param->nValue[1], TRUE);
		SetDlgItemInt(hwnd, IDC_EDIT3, param->nValue[2], TRUE);
		SetDlgItemInt(hwnd, IDC_EDIT4, param->nValue[3], TRUE);
		SetDlgItemText(hwnd, IDC_EDIT5, param->szText[0]);
		SetDlgItemText(hwnd, IDC_EDIT6, param->szText[1]);
		SetDlgItemText(hwnd, IDC_EDIT7, param->szText[2]);
		SetDlgItemText(hwnd, IDC_EDIT8, param->szText[3]);
		break;
	case WM_DESTROY:
		param->nValue[0] = GetDlgItemInt(hwnd, IDC_EDIT1, NULL, TRUE);
		param->nValue[1] = GetDlgItemInt(hwnd, IDC_EDIT2, NULL, TRUE);
		param->nValue[2] = GetDlgItemInt(hwnd, IDC_EDIT3, NULL, TRUE);
		param->nValue[3] = GetDlgItemInt(hwnd, IDC_EDIT4, NULL, TRUE);
		GetDlgItemText(hwnd, IDC_EDIT5, param->szText[0], MAX_PATH);
		GetDlgItemText(hwnd, IDC_EDIT6, param->szText[1], MAX_PATH);
		GetDlgItemText(hwnd, IDC_EDIT7, param->szText[2], MAX_PATH);
		GetDlgItemText(hwnd, IDC_EDIT8, param->szText[3], MAX_PATH);
		break;
	default:
		return FALSE;
	}
	return TRUE;
}

BOOL Init(void)
{
	return TRUE;
}

void Quit(void)
{
}

void Config(PREFS* prefs, COMMANDPARAM* param)
{
	prefs->hInstance = plugin.hDllInstance;
	prefs->id = IDD_DIALOG;
	prefs->DlgProc = DlgProc;
	prefs->lParam = (LPARAM)param;
}

void Command(HWND hwnd, LPCWSTR path, COMMANDPARAM* param)
{
	TCHAR szText[1024];
	wsprintf(szText, TEXT("%d%:%d:%d:%d\n%s\n%s\n%s\n%s"),
		param->nValue[0], param->nValue[1], param->nValue[2], param->nValue[3],
		param->szText[0], param->szText[1], param->szText[2], param->szText[3]);
	MessageBox(hwnd, szText, TEXT("sample plugin"), MB_OK);
}
